{%- set is_partitioned = partition_by is defined and partition_by is not none  %}

CREATE EXTERNAL TABLE IF NOT EXISTS `{{ database }}`.`{{ table }}` (

{%- for col_name, type_name in columns.items() %}
    `{{ col_name }}` {{ type_name }}{%- if not loop.last %}, {%- endif %}
{%- endfor %}

)
{%- if is_partitioned %}
{%- if partition_by_type == "integer" %}
PARTITIONED BY(`{{ partition_by }}` bigint)
{%- else %}
PARTITIONED BY(`{{ partition_by }}` string)
{%- endif %}
{%- endif %}

ROW FORMAT SERDE 'org.apache.hadoop.hive.ql.io.parquet.serde.ParquetHiveSerDe'

WITH SERDEPROPERTIES (

'serialization.format' = '1'

) LOCATION '{{ s3_location }}'

TBLPROPERTIES (
'has_encrypted_data'='false'
{%- if is_partitioned %}
,'projection.enabled'='true',
'projection.{{ partition_by }}.type'='{{ partition_by_type }}',
'projection.{{ partition_by }}.range'='{{ partition_by_range_from }},{{ partition_by_range_to }}'
{%- if partition_by_format %}
,'projection.{{ partition_by }}.format'='{{ partition_by_format }}'
{%- endif %}

{%- if partition_by_interval %}
,'projection.{{ partition_by }}.interval'='{{ partition_by_interval }}'
{%- endif %}

{%- endif %}
);
